function [w, trainErrors, trainZeroOneLosses, testErrors, testZeroOneLosses] = gd(features, labels, rate, epsilon, C, testFeatures, testLabels)
numFeatures = size(features,2);
numExamples = size(features,1);

w = rand(numFeatures,1);
%w = zeros(numFeatures, 1);


trainError = squaredLoss(w, features, labels);
prevTrainError = trainError + epsilon + 1;

trainErrors = [];
trainZeroOneLosses = [];

testErrors = [];
testZeroOneLosses = [];

while( abs(trainError - prevTrainError) > epsilon)

    dw = zeros(size(w));
    for i=1:numExamples
        y=labels(i);
        x=features(i,:)';

        dw = dw + C * (y - w' * x) * x; %- w;
    end


    w = w + rate * dw;

    prevTrainError = trainError;


    trainError = squaredLoss(w, features, labels);

    trainErrors = [ trainErrors, (trainError)];
    trainZeroOneLosses = [trainZeroOneLosses, zeroOneLoss(w, features, labels)];

    testErrors = [ testErrors, squaredLoss(w, testFeatures, testLabels)];
    testZeroOneLosses = [testZeroOneLosses, zeroOneLoss(w, testFeatures, testLabels)];

end


