trainFile = '../data/weather-brown80.sparse.feat';
testFile = '../data/weather-brown20.sparse.feat';

[trainLabels, trainFeatures] = loadWeatherData(trainFile);
[testLabels, testFeatures] = loadWeatherData(testFile);



[w, errors, zeroOneLosses, testErrors, testZeroOneLosses] = gd(trainFeatures, trainLabels, 0.001, 0.001, 1, testFeatures, testLabels);


maxE = max([testErrors, errors]);
maxZ = max([testZeroOneLosses, zeroOneLosses]);
errors = errors/ maxE;
testErrors = testErrors  /maxE;

hold on


plot([errors; zeroOneLosses]');
xlabel('Iteration Number');
legend('Mean Square Loss (scaled)', '0-1 Loss');
title('Performance on training set as training progresses')
hold off

figure
hold on
plot([testErrors; testZeroOneLosses]');
xlabel('Iteration Number');
legend('Mean Square Loss (scaled)', '0-1 Loss');
title('Performance on test set as training progresses')
hold off


%w = perceptron(trainFeatures, trainLabels, 0.1, 0.001);

disp('Train error: ')
disp(zeroOneLoss(w, trainFeatures, trainLabels))

disp('Test error: ')
disp(zeroOneLoss(w, testFeatures, testLabels))



